// Copyright 2015-2017 by Jon Dart. All Rights Reserved.
//
// definitions of scoring parameters, non-const for tuning

// These have a 1-1 mapping to the tuning parameters
score_t Scoring::Params::RB_ADJUST[4] = {250, 75, -75, -250};
score_t Scoring::Params::RBN_ADJUST[4] = {500, 675, 825, 1000};
score_t Scoring::Params::QR_ADJUST[4] = {-500, 0, 500, 500};
score_t Scoring::Params::KN_VS_PAWN_ADJUST[3] = {0, -2400, -1500};
score_t Scoring::Params::CASTLING[6] = {0, -70, -100, 280, 200, -280};
#ifdef TUNE
score_t Scoring::Params::KING_ATTACK_SCALE_MAX;
score_t Scoring::Params::KING_ATTACK_SCALE_INFLECT;
score_t Scoring::Params::KING_ATTACK_SCALE_FACTOR;
score_t Scoring::Params::KING_ATTACK_SCALE_BIAS;
#endif
score_t Scoring::Params::KING_COVER[6][4];
score_t Scoring::Params::KING_COVER_BASE = -100;
score_t Scoring::Params::KING_DISTANCE_BASIS = 320;
score_t Scoring::Params::KING_DISTANCE_MULT = 80;
score_t Scoring::Params::PIN_MULTIPLIER_MID = 200;
score_t Scoring::Params::PIN_MULTIPLIER_END = 300;
score_t Scoring::Params::ROOK_VS_PAWNS = 333;
score_t Scoring::Params::KRMINOR_VS_R = -100;
score_t Scoring::Params::KRMINOR_VS_R_NO_PAWNS = -500;
score_t Scoring::Params::KQMINOR_VS_Q = -100;
score_t Scoring::Params::KQMINOR_VS_Q_NO_PAWNS = -500;
score_t Scoring::Params::MINOR_FOR_PAWNS = 250;
score_t Scoring::Params::ENDGAME_PAWN_ADVANTAGE = 100;
score_t Scoring::Params::PAWN_ENDGAME1 = 200;
score_t Scoring::Params::PAWN_ENDGAME2 = 300;
score_t Scoring::Params::PAWN_ATTACK_FACTOR1 = 3;
score_t Scoring::Params::PAWN_ATTACK_FACTOR2 = 3;
score_t Scoring::Params::MINOR_ATTACK_FACTOR = 4;
score_t Scoring::Params::MINOR_ATTACK_BOOST = 4;
score_t Scoring::Params::ROOK_ATTACK_FACTOR = 44;
score_t Scoring::Params::ROOK_ATTACK_BOOST2 = 35;
score_t Scoring::Params::ROOK_ATTACK_BOOST = 8;
score_t Scoring::Params::QUEEN_ATTACK_FACTOR = 52;
score_t Scoring::Params::QUEEN_ATTACK_BOOST = 28;
score_t Scoring::Params::QUEEN_ATTACK_BOOST2 = 12;
score_t Scoring::Params::KING_ATTACK_COVER_BOOST_BASE;
score_t Scoring::Params::KING_ATTACK_COVER_BOOST_SLOPE;
score_t Scoring::Params::PAWN_THREAT_ON_PIECE_MID = -50;
score_t Scoring::Params::PAWN_THREAT_ON_PIECE_END = -50;
score_t Scoring::Params::PIECE_THREAT_MM_MID = -50;
score_t Scoring::Params::PIECE_THREAT_MR_MID = -50;
score_t Scoring::Params::PIECE_THREAT_MQ_MID = -50;
score_t Scoring::Params::PIECE_THREAT_MM_END = -50;
score_t Scoring::Params::PIECE_THREAT_MR_END = -50;
score_t Scoring::Params::PIECE_THREAT_MQ_END = -50;
score_t Scoring::Params::MINOR_PAWN_THREAT_MID = -50;
score_t Scoring::Params::MINOR_PAWN_THREAT_END = -50;
score_t Scoring::Params::PIECE_THREAT_RM_MID = -50;
score_t Scoring::Params::PIECE_THREAT_RR_MID = -50;
score_t Scoring::Params::PIECE_THREAT_RQ_MID = -50;
score_t Scoring::Params::PIECE_THREAT_RM_END = -50;
score_t Scoring::Params::PIECE_THREAT_RR_END = -50;
score_t Scoring::Params::PIECE_THREAT_RQ_END = -50;
score_t Scoring::Params::ROOK_PAWN_THREAT_MID = -50;
score_t Scoring::Params::ROOK_PAWN_THREAT_END = -50;
score_t Scoring::Params::ENDGAME_KING_THREAT = -50;
score_t Scoring::Params::BISHOP_TRAPPED = -1470;
score_t Scoring::Params::BISHOP_PAIR_MID = 420;
score_t Scoring::Params::BISHOP_PAIR_END = 550;
score_t Scoring::Params::BISHOP_PAWN_PLACEMENT_END = -160;
score_t Scoring::Params::BAD_BISHOP_MID = -40;
score_t Scoring::Params::BAD_BISHOP_END = -60;
score_t Scoring::Params::OUTPOST_NOT_DEFENDED = 42;
score_t Scoring::Params::CENTER_PAWN_BLOCK = -120;
score_t Scoring::Params::OUTSIDE_PASSER_MID = 120;
score_t Scoring::Params::OUTSIDE_PASSER_END = 250;
score_t Scoring::Params::WEAK_PAWN_MID = -80;
score_t Scoring::Params::WEAK_PAWN_END = -80;
score_t Scoring::Params::WEAK_ON_OPEN_FILE_MID = -100;
score_t Scoring::Params::WEAK_ON_OPEN_FILE_END = -100;
score_t Scoring::Params::SPACE = 20;
score_t Scoring::Params::PAWN_CENTER_SCORE_MID = 30;
score_t Scoring::Params::ROOK_ON_7TH_MID = 260;
score_t Scoring::Params::ROOK_ON_7TH_END = 260;
score_t Scoring::Params::TWO_ROOKS_ON_7TH_MID = 570;
score_t Scoring::Params::TWO_ROOKS_ON_7TH_END = 660;
score_t Scoring::Params::ROOK_ON_OPEN_FILE_MID = 200;
score_t Scoring::Params::ROOK_ON_OPEN_FILE_END = 200;
score_t Scoring::Params::ROOK_BEHIND_PP_MID = 50;
score_t Scoring::Params::ROOK_BEHIND_PP_END = 100;
score_t Scoring::Params::QUEEN_OUT = -60;
score_t Scoring::Params::PAWN_SIDE_BONUS = 306;
score_t Scoring::Params::KING_OWN_PAWN_DISTANCE = 50;
score_t Scoring::Params::KING_OPP_PAWN_DISTANCE = 20;
score_t Scoring::Params::QUEENING_SQUARE_CONTROL_MID = 200;
score_t Scoring::Params::QUEENING_SQUARE_CONTROL_END = 400;
score_t Scoring::Params::QUEENING_SQUARE_OPP_CONTROL_MID = -200;
score_t Scoring::Params::QUEENING_SQUARE_OPP_CONTROL_END = -400;
score_t Scoring::Params::WRONG_COLOR_BISHOP = -400;
score_t Scoring::Params::SIDE_PROTECTED_PAWN = -92;
score_t Scoring::Params::KING_ATTACK_COUNT_BOOST[3] = {6,12,15};
score_t Scoring::Params::KING_OPP_PASSER_DISTANCE[6] = {10,20,30,40,50,60};
score_t Scoring::Params::KNIGHT_PST[2][64];
score_t Scoring::Params::BISHOP_PST[2][64];
score_t Scoring::Params::ROOK_PST[2][64];
score_t Scoring::Params::QUEEN_PST[2][64];
score_t Scoring::Params::KING_PST[2][64];

// The following tables are computed from tuning parameters.
score_t Scoring::Params::KING_POSITION_LOW_MATERIAL[3];
score_t Scoring::Params::TRADE_DOWN[8];
score_t Scoring::Params::KING_ATTACK_SCALE[Scoring::Params::KING_ATTACK_SCALE_SIZE];
score_t Scoring::Params::PASSED_PAWN[2][8];
score_t Scoring::Params::PASSED_PAWN_FILE_ADJUST[8] = {0,0,0,0,0,0,0,0};
score_t Scoring::Params::POTENTIAL_PASSER[2][8];
score_t Scoring::Params::CONNECTED_PASSER[2][8];
score_t Scoring::Params::ADJACENT_PASSER[2][8];
score_t Scoring::Params::PP_OWN_PIECE_BLOCK[2][21];
score_t Scoring::Params::PP_OPP_PIECE_BLOCK[2][21];
score_t Scoring::Params::DOUBLED_PAWNS[2][8];
score_t Scoring::Params::TRIPLED_PAWNS[2][8];
score_t Scoring::Params::ISOLATED_PAWN[2][8];
score_t Scoring::Params::KNIGHT_OUTPOST[3][64];
score_t Scoring::Params::BISHOP_OUTPOST[3][64];
score_t Scoring::Params::KNIGHT_MOBILITY[9];
score_t Scoring::Params::BISHOP_MOBILITY[15];
score_t Scoring::Params::ROOK_MOBILITY[2][15];
score_t Scoring::Params::QUEEN_MOBILITY[2][29];
score_t Scoring::Params::KING_MOBILITY_ENDGAME[5];

